open Spoc			

let _ =
	Random.self_init();
	let devices = Devices.init ~only:Devices.Cuda () in
		Cublas.run ();
		let dev = devices.(0) in
		let a = Vector.create Vector.float32 1024 in
		for i = 0 to (Vector.length a - 1) do
				Mem.unsafe_set a i ((Random.float 1.) +. 1.);
		done;
		Mem.to_device a dev;
		let b = Cublas.run dev (Cublas.cublasSasum 1024 a 1);
		 in Printf.printf "Res = %g\n" b;
			Mem.to_cpu a ;
			let mlres= ref 0. in
			for i=0 to (Vector.length a - 1) do
				mlres := !mlres +. (Mem.unsafe_get a i)
			done;
			Printf.printf "MLRes = %g\n" !mlres;
			
			let a2 = Vector.create Vector.complex32 1024 in
				for i = 0 to (Vector.length a2 - 1) do
					Mem.unsafe_set a2 i {Complex.re=Random.float 32.; Complex.im=Random.float 32.};
				done;
			Mem.to_device a2 dev;
			let b2 = Cublas.run dev (Cublas.cublasScasum 1024 a2 1);
			in Printf.printf "Res = %g\n" b2;
			Mem.to_cpu a2 ;
			let mlres2 = ref Complex.zero in
			for i= 0 to (Vector.length a2 - 1) do
				mlres2 := Complex.add !mlres2  (Mem.unsafe_get a2 i)
			done;
			Printf.printf "MLRes = %g + i%g  => %g\n" !mlres2.Complex.re !mlres2.Complex.im (!mlres2.Complex.re +. !mlres2.Complex.im);
			Cublas.shutdown ()