open Spoc

let check_auto vecs dev= 
	if !Mem.auto then
		(
		for i = 0 to Array.length vecs - 1 do
			match vecs.(i).Vector.dev with
				| Vector.No_dev  -> Mem.to_device vecs.(i) dev
				| Vector.Dev d  -> 
					if d != dev then
						Mem.to_device vecs.(i) dev
		done;
		Devices.flush dev ()
		)
		
external init: int -> unit = "spoc_clAmdBlasInit"
external shutdown: unit -> unit = "spoc_cublasShutdown"

let init () =
	init !(Spoc.Devices.cuda_compatible_devices)
	
	
(** Blas3 *)
(** Single-Precision Blas3 functions *)			

external clAmdBlasSgemm: char -> char -> int -> int -> int -> float -> Vector.vfloat32 -> int -> Vector.vfloat32 -> int -> float -> Vector.vfloat32 -> int -> Devices.device -> unit = "spoc_clAmdBlasSgemm_b" "spoc_clAmdBlasSgemm_n"																		

let clAmdBlasSgemm transa transb m n k alpha a lda b ldb beta c ldc dev =
	check_auto [|a; b; c|] dev;
	clAmdBlasSgemm transa transb m n k alpha a lda b ldb beta c ldc dev
	
																									
let run dev f =
	f dev 