open Devices
open Vector


(*let _ = 
	cuda_init();*)
	
	
exception No_Cuda_Device 
exception ERROR_DEINITIALIZED
exception ERROR_NOT_INITIALIZED
exception ERROR_INVALID_CONTEXT
exception ERROR_INVALID_VALUE
exception ERROR_OUT_OF_MEMORY
exception ERROR_INVALID_DEVICE
exception ERROR_NOT_FOUND
exception ERROR_FILE_NOT_FOUND
exception ERROR_UNKNOWN
exception ERROR_LAUNCH_FAILED
exception ERROR_LAUNCH_OUT_OF_RESOURCES
exception ERROR_LAUNCH_TIMEOUT
exception ERROR_LAUNCH_INCOMPATIBLE_TEXTURING


let _ = 
	Callback.register_exception "no_cuda_device" No_Cuda_Device;
	Callback.register_exception "cuda_error_deinitialized" ERROR_DEINITIALIZED;
	Callback.register_exception "cuda_error_not_initialized" ERROR_NOT_INITIALIZED;
	Callback.register_exception "cuda_error_invalid_context" ERROR_INVALID_CONTEXT;
	Callback.register_exception "cuda_error_invalid_value" ERROR_INVALID_VALUE;
	Callback.register_exception "cuda_error_out_of_memory" ERROR_OUT_OF_MEMORY;
	Callback.register_exception "cuda_error_invalid_device" ERROR_INVALID_DEVICE;
	Callback.register_exception "cuda_error_not_found" ERROR_NOT_FOUND;
	Callback.register_exception "cuda_error_file_not_found" ERROR_FILE_NOT_FOUND;
	Callback.register_exception "cuda_error_launch_failed" ERROR_LAUNCH_FAILED;
	Callback.register_exception "cuda_error_launch_out_of_resources" ERROR_LAUNCH_OUT_OF_RESOURCES;
	Callback.register_exception "cuda_error_launch_timeout" ERROR_LAUNCH_TIMEOUT;
	Callback.register_exception "cuda_error_launch_incompatible_texturing" ERROR_LAUNCH_INCOMPATIBLE_TEXTURING;
	Callback.register_exception "cuda_error_unknown" ERROR_UNKNOWN


external cuda_cpu_to_device :  ('a,'b)vector -> int -> generalInfo ->  unit = "spoc_cuda_cpu_to_device"
external cuda_device_to_device : ('a,'b)vector -> int -> device -> unit = "spoc_cuda_device_to_device"
external cuda_device_to_cpu : ('a,'b)vector -> int -> generalInfo -> unit = "spoc_cuda_device_to_cpu"
external cuda_custom_cpu_to_device :
  ('a, 'b) vector -> int -> generalInfo -> unit =
  "spoc_cuda_custom_cpu_to_device"
  
external cuda_custom_device_to_cpu :
  ('a, 'b) vector -> int -> generalInfo -> unit =
  "spoc_cuda_custom_device_to_cpu"
	
	