#include "Spoc_clAmdBlas.h"
//#include "Opencl_dynlink.h"

int cuda_compatible_device = 0;

CAMLprim value spoc_clAmdBlasInit(value cudaDevices){
	CAMLparam1(cudaDevices);
	cl_int opencl_error = 0;
	cuda_compatible_device = Int_val(cudaDevices);
	OPENCL_CHECK_CALL1(opencl_error, clAmdBlasSetup());
	CAMLreturn( Val_unit);
}


CAMLprim value spoc_clAmdBlasShutdown(){
	clAmdBlasTeardown();
	return Val_unit;
}


#define GET_HOST_VEC(vec, h_vec) \
	bigArray = Field(vec, 1); \
	h_vec = Data_bigarray_val(bigArray);

#define GET_VEC(vec, d_vec) \
	dev_vec_array = Field(vec, 3); \
	dev_vec = Field(dev_vec_array, id-cuda_compatible_device); \
	d_vec = Cl_mem_val(Field(dev_vec, 1));

#define CLAMDBLAS_FUN(fun, arg, arg2) \
		CAMLprim value fun##_n arg {\
			return fun arg2 ;\
		}\
		CAMLprim value fun##_b arg {\
			return fun arg2 ;\
		}

void pfn_notify2(const char *errinfo, const void *private_info, size_t cb, void *user_data)
{
   fprintf(stderr, "%s\n", errinfo);
   fflush(stderr);
}

/* Single-Precision BLAS3 functions */

CAMLprim value spoc_clAmdBlasSgemm(value transa, value transb,
		value m, value n, value k,
		value alpha, value a, value lda,
		value b, value ldb, value beta, value c, value ldc, value dev){
	CAMLparam5(transa, transb, m, n, k);
	CAMLxparam5(alpha, a, lda, b, ldb);
	CAMLxparam4(beta, c, ldc, dev);
	CAMLlocal3(dev_vec_array, dev_vec, gi);

	int id;
	cl_event event = NULL;
	gi = Field(dev, 0);
	id = Int_val(Field(gi, 8));
	cl_int device_id = id-cuda_compatible_device;
	cl_uint num_entries = 10;
		cl_platform_id platform_ids[10];
		const cl_uint max_num_devices = 80;
		int platform_id;
		cl_device_id *device_ids;
		//[max_num_devices];

		cl_uint  num_platforms;

		cl_uint infoUInt;
		cl_ulong infoULong;
		cl_bool infoBool;
	    cl_device_type infoType;
	    cl_device_mem_cache_type infoMemType = 0;
	    cl_device_fp_config singleFPConfig;
	    cl_command_queue_properties commandQueueProperties;
		char infoStr[1024];
		cl_device_local_mem_type localMemType;
		size_t infoLen;
		cl_uint num_devices;
		cl_uint total_num_devices = 0;
		cl_context ctx;
		cl_command_queue queue[2];
		cl_context_properties properties[3];
		cl_device_id dev_id[1];
		spoc_cl_context *spoc_ctx;
		int opencl_error;

		device_ids = malloc(sizeof(cl_device_id)*max_num_devices);
		OPENCL_TRY ("clGetPlatformIds", clGetPlatformIDs ( num_entries, platform_ids, &num_platforms));


//	cl_mem d_A;
//	cl_mem d_B;
//	cl_mem d_C;
//	clAmdBlasOrder order = clAmdBlasRowMajor; //rowMajorOnly for now
//	clAmdBlasTranspose tA, tB;
//
//
//	cl_int device_id = id-cuda_compatible_device;
//
//	cl_uint num_entries = 10;
//	cl_platform_id platform_ids[10];
//	const cl_uint max_num_devices = 80;
//	int platform_id;
//	cl_device_id *device_ids;
//	//[max_num_devices];
//	int i;
//	cl_uint  num_platforms;
//
//	cl_uint infoUInt;
//	cl_ulong infoULong;
//	cl_bool infoBool;
//    cl_device_type infoType;
//    cl_device_mem_cache_type infoMemType = 0;
//    cl_device_fp_config fPConfig;
//    cl_device_exec_capabilities execCapabilities;
//
//    cl_command_queue_properties commandQueueProperties;
//	char infoStr[1024];
//	cl_device_local_mem_type localMemType;
//	size_t infoLen;
//	size_t infoSize;
//	cl_uint num_devices;
//	cl_uint infoDimension;
//	cl_uint total_num_devices = 0;
//	size_t *work_sizes;
//	cl_context_properties properties[3];
//	cl_device_id dev_id[1];
//	cl_int opencl_error = 0;
//
//	cl_command_queue q;
//	cl_context ctx2;
//
//	device_ids = malloc(sizeof(cl_device_id)*max_num_devices);
//	OPENCL_TRY ("clGetPlatformIds", clGetPlatformIDs (num_entries, platform_ids, &num_platforms));
//
//		for(platform_id = 0; platform_id < num_platforms; platform_id++) {
//			OPENCL_TRY("clGetDeviceIDs", clGetDeviceIDs( platform_ids[platform_id], CL_DEVICE_TYPE_ALL, max_num_devices, device_ids, &num_devices));
//			total_num_devices += num_devices;
//		}
//		if (device_id > total_num_devices)
//			raise_constant(*caml_named_value("no_opencl_device")) ;
//
//	for(platform_id = 0; platform_id < num_platforms; platform_id++) {
//		OPENCL_TRY("clGetDeviceIDs", clGetDeviceIDs( platform_ids[platform_id], CL_DEVICE_TYPE_ALL, max_num_devices, device_ids, &num_devices));
//
//			if (num_devices > device_id)
//			{
//				//OPENCL_TRY("clGetDeviceInfo", clGetDeviceInfo ( device_ids[device_id], CL_DEVICE_AVAILABLE , sizeof(infoBool), &infoBool, &infoLen ));
//	            dev_id[0] = device_ids[device_id];
//
//				properties[0] = CL_CONTEXT_PLATFORM;
//				            properties[1] = (cl_context_properties) platform_ids[platform_id];
//				            properties[2] = 0;
//				            OPENCL_CHECK_CALL1(ctx2, clCreateContext(properties, 1, dev_id, pfn_notify2, NULL, &opencl_error));
//
//				q = clCreateCommandQueue(ctx2, dev_id[0], 0, NULL);
//				break;
//
//			}else device_id -=num_devices;
//	}
//
//
//	CLAMDBLAS_GET_CONTEXT;
//
//		GET_VEC(a, d_A);
//		GET_VEC(b, d_B);
//		GET_VEC(c, d_C);
//		printf ("id: %d - dA: %p - dB: %p - dC: %p\n", id-cuda_compatible_device, d_A, d_B, d_C);
//		printf ("queue : %p, ctx :  %p\n", queue[0], ctx);fflush(stdout);
//
//		if (Int_val(transa) == 'n' || Int_val(transa) == 'N')
//			tA = clAmdBlasNoTrans ;
//		if (Int_val(transa) == 't' || Int_val(transa) == 'T')
//			tA = clAmdBlasTrans;
//		if (Int_val(transa) == 'c' || Int_val(transa) == 'C')
//			tA = clAmdBlasConjTrans;
//
//		if (Int_val(transb) == 'n' || Int_val(transb) == 'N')
//			tB = clAmdBlasNoTrans ;
//		if (Int_val(transb) == 't' || Int_val(transb) == 'T')
//			tB = clAmdBlasTrans;
//		if (Int_val(transb) == 'c' || Int_val(transb) == 'C')
//			tB = clAmdBlasConjTrans;
//
////	cl_uint numCommandQueues, cl_command_queue * commandQueues, cl_uint
////	numEventsInWaitList, const cl_event * eventWaitList, cl_event * events)
//	//OPENCL_CHECK_CALL1(opencl_error, clFinish(queue[0]));
////	cl_device_id device[1];// = malloc (sizeof(cl_device_id)*10);
////	size_t size;
////	printf ("++++ ctx %p-%p\n", &ctx, ctx );fflush (stdout);
////
////	OPENCL_CHECK_CALL1(opencl_error,clGetContextInfo(ctx, CL_CONTEXT_DEVICES, sizeof(cl_device_id), NULL, &size));
////	printf ("++++%d", (uint)size); fflush(stdout); fflush (stdout);
////
//	//cl_command_queue q = clCreateCommandQueue(ctx, device[0], 0, NULL);
//
//	OPENCL_CHECK_CALL1(opencl_error, clAmdBlasSgemm (order, tA, tB, (size_t)Int_val(m), (size_t)Int_val(n),
//			(size_t)Int_val(k), (float)Double_val(alpha), d_A, Int_val(lda),
//	d_B, Int_val(ldb), (float) Double_val(beta),
//	d_C, Int_val(ldc), 1, &q, 0, NULL, &event));
//
//	OPENCL_CHECK_CALL1(opencl_error, clWaitForEvents(1, &event));
//
//
//	CLAMDBLAS_RESTORE_CONTEXT;

	CAMLreturn(Val_unit);
}

CLAMDBLAS_FUN(spoc_clAmdBlasSgemm, (value transa, value transb, value m, value n, value k, value alpha, value a, value lda, value b, value ldb, value beta, value c, value ldc, value dev),(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc, dev) );
