external sizeofbool : unit -> int = "custom_getsizeofbool"
external boolget : Vector.customarray -> int -> bool = "custom_boolget"
external boolset : Vector.customarray -> int -> bool -> unit
  = "custom_boolset"
val print : int -> unit
val iter : ('a -> 'b) -> ('a, 'c) Vector.vector -> unit
val iteri : ('a -> int -> 'b) -> ('a, 'c) Vector.vector -> unit
val map :
  ('a -> 'b) ->
  ('b, 'c) Vector.kind -> ('a, 'd) Vector.vector -> ('b, 'c) Vector.vector
val trueCustom : bool Vector.custom
val falseCustom : bool Vector.custom
val fold_left : ('a -> 'b -> 'a) -> 'a -> ('b, 'c) Vector.vector -> 'a
val fold_right : ('a -> 'b -> 'b) -> ('a, 'c) Vector.vector -> 'b -> 'b
val vfalse : (bool, 'a) Vector.kind
val vtrue : (bool, 'a) Vector.kind
val spoc_bool : (bool, 'a) Vector.kind
type vbool = bool Vector.vcustom
module Gpu :
  sig
    val gpuSum :
      bool Vector.vcustom ->
      Vector.vint32 ->
      Vector.vint32 ->
      Kernel.block * Kernel.grid -> bool -> int -> Devices.device -> unit
    val sum : vbool -> Devices.device -> Kernel.block * Kernel.grid -> int
    val int_bubble_filter :
      bool Vector.vcustom ->
      Vector.vint32 ->
      Vector.vint32 ->
      Kernel.block * Kernel.grid -> bool -> int -> Devices.device -> unit
    val filter :
      Devices.device ->
      Kernel.block * Kernel.grid ->
      ('a, 'b) Vector.vector -> ('a -> bool) -> ('a, 'b) Vector.vector
    val maskFilter :
      Devices.device ->
      Kernel.block * Kernel.grid ->
      Vector.vint32 ->
      bool Vector.vcustom -> (int32, Bigarray.int32_elt) Vector.vector
  end
